Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ 7ebadeb3

History | View | Annotate | Download (48 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 08366664 Michael Hanselmann
# Helper values for calling builtin functions
13 08366664 Michael Hanselmann
empty :=
14 08366664 Michael Hanselmann
space := $(empty) $(empty)
15 08366664 Michael Hanselmann
comma := ,
16 08366664 Michael Hanselmann
17 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
18 a01dd3c6 Iustin Pop
SHELL=/bin/bash
19 a01dd3c6 Iustin Pop
20 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
21 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 5d3c30df Michael Hanselmann
CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 c55cc346 Iustin Pop
CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 73d0e218 Iustin Pop
CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 f6cbcc06 Michael Hanselmann
CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
31 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
32 d99d1e36 Iustin Pop
CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 d5a2a550 Michael Hanselmann
BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 6e3bf290 Michael Hanselmann
SHELL_ENV_INIT = autotools/shell-env-init
35 e8230860 Michael Hanselmann
36 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
37 22c5390d Iustin Pop
# the directory + 'dir' suffix
38 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
39 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
40 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
41 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
42 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
43 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
44 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
45 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
46 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
47 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
48 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
49 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
50 0d2bf835 René Nussbaumer
pytoolsdir = $(pkgpythondir)/tools
51 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
52 b8fe7ca6 Iustin Pop
myexeclibdir = $(pkglibdir)
53 e8230860 Michael Hanselmann
54 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
55 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
56 a4f12da4 Michael Hanselmann
57 d5506465 Iustin Pop
HTOOLS_DIRS = \
58 d5506465 Iustin Pop
	htools \
59 d5506465 Iustin Pop
	htools/Ganeti \
60 358a0a8f Iustin Pop
	htools/Ganeti/Confd \
61 458a286a Iustin Pop
	htools/Ganeti/HTools \
62 4cbe9bda Iustin Pop
	htools/Ganeti/HTools/Program \
63 f0f3a6df Iustin Pop
	htools/Ganeti/Query \
64 e5a29b6c Iustin Pop
	htest \
65 e5a29b6c Iustin Pop
	htest/Test \
66 2733df51 Iustin Pop
	htest/Test/Ganeti \
67 aed2325f Iustin Pop
	htest/Test/Ganeti/Confd \
68 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools \
69 aed2325f Iustin Pop
	htest/Test/Ganeti/Query
70 d5506465 Iustin Pop
71 e8230860 Michael Hanselmann
DIRS = \
72 e8230860 Michael Hanselmann
	autotools \
73 e8230860 Michael Hanselmann
	daemons \
74 e8230860 Michael Hanselmann
	devel \
75 e8230860 Michael Hanselmann
	doc \
76 e8230860 Michael Hanselmann
	doc/examples \
77 d6d9ce45 Guido Trotter
	doc/examples/hooks \
78 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
79 d5506465 Iustin Pop
	$(HTOOLS_DIRS) \
80 e8230860 Michael Hanselmann
	lib \
81 2d48a3a2 Michael Hanselmann
	lib/client \
82 f9897b6d Michael Hanselmann
	lib/build \
83 2f16ea8f Michael Hanselmann
	lib/confd \
84 ff9efc03 Michael Hanselmann
	lib/http \
85 e8230860 Michael Hanselmann
	lib/hypervisor \
86 bb44b1ae Michael Hanselmann
	lib/impexpd \
87 dc101ecc Michael Hanselmann
	lib/masterd \
88 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
89 899c4d2c Michael Hanselmann
	lib/server \
90 0d2bf835 René Nussbaumer
	lib/tools \
91 c047a981 Michael Hanselmann
	lib/utils \
92 9f4bb951 Michael Hanselmann
	lib/watcher \
93 e8230860 Michael Hanselmann
	man \
94 e8230860 Michael Hanselmann
	qa \
95 e8230860 Michael Hanselmann
	test \
96 e8230860 Michael Hanselmann
	test/data \
97 1e6fab60 Agata Murawska
	test/data/ovfdata \
98 d92518d3 Agata Murawska
	test/data/ovfdata/other \
99 8feabc89 Iustin Pop
	htest/data \
100 8feabc89 Iustin Pop
	htest/data/rapi \
101 662de722 Iustin Pop
	htest/shelltests \
102 e8230860 Michael Hanselmann
	tools
103 e8230860 Michael Hanselmann
104 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
105 c964d962 Michael Hanselmann
	scripts \
106 22c5390d Iustin Pop
	$(APIDOC_DIR) \
107 22c5390d Iustin Pop
	$(APIDOC_PY_DIR) \
108 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
109 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti \
110 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Confd \
111 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools \
112 458a286a Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Program \
113 662de722 Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Query \
114 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
115 22c5390d Iustin Pop
	$(COVERAGE_PY_DIR) \
116 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
117 b91e9518 Iustin Pop
	.hpc
118 2750b299 Michael Hanselmann
119 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
120 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
121 6b997854 Michael Hanselmann
	doc/html
122 6b997854 Michael Hanselmann
123 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
124 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
125 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
126 6b997854 Michael Hanselmann
	doc/html/_*
127 6b997854 Michael Hanselmann
128 22c5390d Iustin Pop
# some helper vars
129 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
130 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
131 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
132 22c5390d Iustin Pop
APIDOC_DIR = doc/api
133 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
134 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
135 22c5390d Iustin Pop
136 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
137 d17e74b4 Iustin Pop
	$(docpng) \
138 b76aac08 Michael Hanselmann
	$(maninput) \
139 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
140 84a12e40 Iustin Pop
	doc/news.rst \
141 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
142 84a12e40 Iustin Pop
	vcs-version
143 2ab2b9f5 Iustin Pop
144 d17e74b4 Iustin Pop
maintainer-clean-local:
145 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
146 d17e74b4 Iustin Pop
147 e8230860 Michael Hanselmann
CLEANFILES = \
148 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
149 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
150 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
151 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
152 f774bd03 Michael Hanselmann
	epydoc.conf \
153 5098afd1 Iustin Pop
	$(REPLACE_VARS_SED) \
154 6e3bf290 Michael Hanselmann
	$(SHELL_ENV_INIT) \
155 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
156 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
157 2958c56e Michael Hanselmann
	daemons/ganeti-master-cleaner \
158 e8230860 Michael Hanselmann
	devel/upload \
159 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
160 f72f8622 Iustin Pop
	doc/examples/bash_completion \
161 e80aeb89 Michael Hanselmann
	doc/examples/bash_completion-debug \
162 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py \
163 2ab2b9f5 Iustin Pop
	$(man_MANS) \
164 2ab2b9f5 Iustin Pop
	$(manhtml) \
165 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
166 e5afb848 Michael Hanselmann
	tools/vcluster-setup \
167 3735787e Iustin Pop
	stamp-directories \
168 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
169 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
170 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
171 3096524e Iustin Pop
	$(HS_BUILT_TEST_HELPERS) \
172 f0f3a6df Iustin Pop
	.hpc/*.mix htools/*.tix htest/*.tix \
173 191ff68c Iustin Pop
	doc/hs-lint.html
174 e8230860 Michael Hanselmann
175 4c3d5fb6 Iustin Pop
GENERATED_FILES = \
176 5098afd1 Iustin Pop
	$(built_base_sources) \
177 96a7481d Michael Hanselmann
	$(BUILT_PYTHON_SOURCES) \
178 96a7481d Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
179 96a7481d Michael Hanselmann
180 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES =
181 ada0e680 Iustin Pop
if WANT_HTOOLS
182 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES += $(HS_PROGS)
183 ada0e680 Iustin Pop
if HS_CONFD
184 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES += htools/hconfd
185 ada0e680 Iustin Pop
endif
186 ada0e680 Iustin Pop
endif
187 ada0e680 Iustin Pop
188 96a7481d Michael Hanselmann
built_base_sources = \
189 3735787e Iustin Pop
	stamp-directories \
190 3735787e Iustin Pop
	stamp-srclinks
191 2d1f248e Michael Hanselmann
192 96a7481d Michael Hanselmann
built_python_base_sources = \
193 13aeae6a Iustin Pop
	lib/_autoconf.py \
194 96a7481d Michael Hanselmann
	lib/_vcsversion.py
195 96a7481d Michael Hanselmann
196 96a7481d Michael Hanselmann
BUILT_PYTHON_SOURCES = \
197 96a7481d Michael Hanselmann
	$(built_python_base_sources) \
198 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py
199 e8230860 Michael Hanselmann
200 5098afd1 Iustin Pop
# Generating the RPC wrappers depends on many things, so make sure
201 5098afd1 Iustin Pop
# it's built at the end of the built sources
202 96a7481d Michael Hanselmann
lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
203 96a7481d Michael Hanselmann
204 656a7fdf Iustin Pop
# these are all built from the underlying %.in sources
205 656a7fdf Iustin Pop
BUILT_EXAMPLES = \
206 656a7fdf Iustin Pop
	doc/examples/ganeti-kvm-poweroff.initd \
207 656a7fdf Iustin Pop
	doc/examples/ganeti.cron \
208 656a7fdf Iustin Pop
	doc/examples/ganeti.initd \
209 656a7fdf Iustin Pop
	doc/examples/gnt-config-backup \
210 656a7fdf Iustin Pop
	doc/examples/hooks/ipsec
211 656a7fdf Iustin Pop
212 08366664 Michael Hanselmann
nodist_pkgpython_PYTHON = \
213 08366664 Michael Hanselmann
	$(BUILT_PYTHON_SOURCES)
214 08366664 Michael Hanselmann
215 f9897b6d Michael Hanselmann
noinst_PYTHON = \
216 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
217 7142485a Iustin Pop
	lib/build/sphinx_ext.py \
218 7142485a Iustin Pop
	lib/build/shell_example_lexer.py
219 f9897b6d Michael Hanselmann
220 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
221 e8230860 Michael Hanselmann
	lib/__init__.py \
222 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
223 e8230860 Michael Hanselmann
	lib/backend.py \
224 e8230860 Michael Hanselmann
	lib/bdev.py \
225 e8230860 Michael Hanselmann
	lib/bootstrap.py \
226 e8230860 Michael Hanselmann
	lib/cli.py \
227 e8230860 Michael Hanselmann
	lib/cmdlib.py \
228 cea881e5 Michael Hanselmann
	lib/compat.py \
229 e8230860 Michael Hanselmann
	lib/config.py \
230 e8230860 Michael Hanselmann
	lib/constants.py \
231 821d9e43 Michael Hanselmann
	lib/daemon.py \
232 e8230860 Michael Hanselmann
	lib/errors.py \
233 62e0e880 Iustin Pop
	lib/ht.py \
234 e8230860 Michael Hanselmann
	lib/jqueue.py \
235 8b537bb0 Michael Hanselmann
	lib/jstore.py \
236 e8230860 Michael Hanselmann
	lib/locking.py \
237 e8230860 Michael Hanselmann
	lib/luxi.py \
238 e8230860 Michael Hanselmann
	lib/mcpu.py \
239 a744b676 Manuel Franceschini
	lib/netutils.py \
240 e8230860 Michael Hanselmann
	lib/objects.py \
241 32683096 René Nussbaumer
	lib/objectutils.py \
242 e8230860 Michael Hanselmann
	lib/opcodes.py \
243 ced78a66 Agata Murawska
	lib/ovf.py \
244 3329f4de Michael Hanselmann
	lib/pathutils.py \
245 a123dc19 Michael Hanselmann
	lib/qlang.py \
246 4ca96421 Michael Hanselmann
	lib/query.py \
247 e8230860 Michael Hanselmann
	lib/rpc.py \
248 6648cb36 Michael Hanselmann
	lib/rpc_defs.py \
249 f12e1736 René Nussbaumer
	lib/runtime.py \
250 e8230860 Michael Hanselmann
	lib/serializer.py \
251 e8230860 Michael Hanselmann
	lib/ssconf.py \
252 e8230860 Michael Hanselmann
	lib/ssh.py \
253 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
254 1338f2b4 Balazs Lecz
	lib/uidpool.py \
255 05e733b4 Michael Hanselmann
	lib/vcluster.py \
256 76094e37 Michael Hanselmann
	lib/workerpool.py
257 e8230860 Michael Hanselmann
258 2d48a3a2 Michael Hanselmann
client_PYTHON = \
259 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
260 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
261 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
262 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
263 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
264 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
265 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
266 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
267 6d50f5f9 Michael Hanselmann
	lib/client/gnt_os.py
268 2d48a3a2 Michael Hanselmann
269 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
270 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
271 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
272 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
273 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
274 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
275 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
276 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
277 e8230860 Michael Hanselmann
278 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
279 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
280 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
281 95ab4de9 David Knowles
	lib/rapi/client.py \
282 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
283 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
284 a85f23fa Michael Hanselmann
	lib/rapi/rlib2.py \
285 a85f23fa Michael Hanselmann
	lib/rapi/testutils.py
286 8c229cc7 Oleksiy Mishchenko
287 ff9efc03 Michael Hanselmann
http_PYTHON = \
288 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
289 be500c29 Michael Hanselmann
	lib/http/auth.py \
290 02cab3e7 Michael Hanselmann
	lib/http/client.py \
291 02cab3e7 Michael Hanselmann
	lib/http/server.py
292 ff9efc03 Michael Hanselmann
293 12426ae1 Guido Trotter
confd_PYTHON = \
294 71f27d19 Guido Trotter
	lib/confd/__init__.py \
295 e4ccf6cd Guido Trotter
	lib/confd/client.py \
296 2f16ea8f Michael Hanselmann
	lib/confd/querylib.py \
297 2f16ea8f Michael Hanselmann
	lib/confd/server.py
298 8c229cc7 Oleksiy Mishchenko
299 dc101ecc Michael Hanselmann
masterd_PYTHON = \
300 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
301 0fcd0cad René Nussbaumer
	lib/masterd/iallocator.py \
302 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
303 dc101ecc Michael Hanselmann
304 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
305 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
306 bb44b1ae Michael Hanselmann
307 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
308 9ca87fb3 Michael Hanselmann
	lib/watcher/__init__.py \
309 adf6301e Michael Hanselmann
	lib/watcher/nodemaint.py \
310 adf6301e Michael Hanselmann
	lib/watcher/state.py
311 9f4bb951 Michael Hanselmann
312 899c4d2c Michael Hanselmann
server_PYTHON = \
313 29d91329 Michael Hanselmann
	lib/server/__init__.py \
314 5c9c0e0e Michael Hanselmann
	lib/server/confd.py \
315 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
316 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
317 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
318 899c4d2c Michael Hanselmann
319 0d2bf835 René Nussbaumer
pytools_PYTHON = \
320 0d2bf835 René Nussbaumer
	lib/tools/__init__.py \
321 0d2bf835 René Nussbaumer
	lib/tools/ensure_dirs.py
322 0d2bf835 René Nussbaumer
323 c047a981 Michael Hanselmann
utils_PYTHON = \
324 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
325 79d22269 Michael Hanselmann
	lib/utils/algo.py \
326 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
327 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
328 3865ca48 Michael Hanselmann
	lib/utils/io.py \
329 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
330 8dc76d54 Guido Trotter
	lib/utils/mlock.py \
331 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
332 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
333 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
334 7831fc5f Michael Hanselmann
	lib/utils/text.py \
335 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
336 c50645c0 Michael Hanselmann
	lib/utils/x509.py
337 c047a981 Michael Hanselmann
338 f05c99f3 Michael Hanselmann
docrst = \
339 ffa6869f Iustin Pop
	doc/admin.rst \
340 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
341 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
342 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
343 1eb85930 Guido Trotter
	doc/design-2.3.rst \
344 92902e91 Iustin Pop
	doc/design-htools-2.3.rst \
345 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
346 d774ce92 Michael Hanselmann
	doc/design-2.5.rst \
347 c95c0f71 Michael Hanselmann
	doc/design-draft.rst \
348 1e86ee97 Marc Schmitt
	doc/design-oob.rst \
349 ae9b5e0f Tsachy Shacham
	doc/design-cpu-pinning.rst \
350 e5a246df Michael Hanselmann
	doc/design-query2.rst \
351 539f195a Michael Hanselmann
	doc/design-x509-ca.rst \
352 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
353 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
354 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
355 4055b109 Adeodato Simo
	doc/design-multi-reloc.rst \
356 eec83a95 Apollon Oikonomopoulos
	doc/design-network.rst \
357 6c3d18e0 Michael Hanselmann
	doc/design-chained-jobs.rst \
358 64ea845e Michael Hanselmann
	doc/design-ovf-support.rst \
359 68640987 Guido Trotter
	doc/design-autorepair.rst \
360 d85f01e7 Iustin Pop
	doc/design-resource-model.rst \
361 d9bdffc3 René Nussbaumer
	doc/cluster-merge.rst \
362 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
363 23f0b93e René Nussbaumer
	doc/design-node-state-cache.rst \
364 6b898285 Iustin Pop
	doc/design-virtual-clusters.rst \
365 4e27516b René Nussbaumer
	doc/design-bulk-create.rst \
366 a47dc554 René Nussbaumer
	doc/design-query-splitting.rst \
367 62947ebb Michael Hanselmann
	doc/devnotes.rst \
368 e2078d28 Iustin Pop
	doc/glossary.rst \
369 4d6443f4 Iustin Pop
	doc/hooks.rst \
370 876860a3 Iustin Pop
	doc/iallocator.rst \
371 d17e74b4 Iustin Pop
	doc/index.rst \
372 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
373 28e15341 Iustin Pop
	doc/install.rst \
374 9725b53d Michael Hanselmann
	doc/locking.rst \
375 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
376 c71a1a3d Iustin Pop
	doc/news.rst \
377 a47dc554 René Nussbaumer
	doc/ovfconverter.rst \
378 6d81475c Iustin Pop
	doc/rapi.rst \
379 b76aac08 Michael Hanselmann
	doc/security.rst \
380 35dd762d Michael Hanselmann
	doc/upgrade.rst \
381 c71a1a3d Iustin Pop
	doc/walkthrough.rst
382 f05c99f3 Michael Hanselmann
383 0985325d Iustin Pop
HS_PROGS = htools/htools
384 22e513e7 Agata Murawska
HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
385 ada0e680 Iustin Pop
HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
386 d6159933 Iustin Pop
387 f0f3a6df Iustin Pop
HS_ALL_PROGS = $(HS_PROGS) htest/test htest/hpc-htools htools/hconfd
388 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
389 189b51fa Iustin Pop
HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
390 3096524e Iustin Pop
391 74e60746 Iustin Pop
HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
392 74e60746 Iustin Pop
# extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
393 d6159933 Iustin Pop
HEXTRA =
394 f0f3a6df Iustin Pop
# internal extra flags (used for htest/test mainly)
395 c7ec3025 Iustin Pop
HEXTRA_INT =
396 b91e9518 Iustin Pop
# exclude options for coverage reports
397 9822b1dd Iustin Pop
HPCEXCL = --exclude Main \
398 98b33d0e Iustin Pop
	--exclude Ganeti.Constants \
399 9822b1dd Iustin Pop
	--exclude Ganeti.THH \
400 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QC \
401 2997cb0a Iustin Pop
	--exclude Ganeti.Version \
402 2733df51 Iustin Pop
	--exclude Test.Ganeti.TestCommon \
403 e1ee7d5a Iustin Pop
	--exclude Test.Ganeti.TestHTools \
404 e1ee7d5a Iustin Pop
	--exclude Test.Ganeti.TestHelper \
405 b88fcdd0 Iustin Pop
	--exclude Test.Ganeti.TestImports \
406 51309138 Iustin Pop
	$(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
407 d6159933 Iustin Pop
408 c3f67183 Iustin Pop
HS_LIB_SRCS = \
409 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
410 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
411 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
412 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
413 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
414 d6159933 Iustin Pop
	htools/Ganeti/HTools/IAlloc.hs \
415 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
416 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
417 d6159933 Iustin Pop
	htools/Ganeti/HTools/Luxi.hs \
418 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
419 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
420 d6159933 Iustin Pop
	htools/Ganeti/HTools/Rapi.hs \
421 d6159933 Iustin Pop
	htools/Ganeti/HTools/Simu.hs \
422 d6159933 Iustin Pop
	htools/Ganeti/HTools/Text.hs \
423 d6159933 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
424 d6159933 Iustin Pop
	htools/Ganeti/HTools/Utils.hs \
425 9f13be88 Iustin Pop
	htools/Ganeti/HTools/Program.hs \
426 458a286a Iustin Pop
	htools/Ganeti/HTools/Program/Hail.hs \
427 201b6c34 Iustin Pop
	htools/Ganeti/HTools/Program/Hbal.hs \
428 22e513e7 Agata Murawska
	htools/Ganeti/HTools/Program/Hcheck.hs \
429 2922d2c5 René Nussbaumer
	htools/Ganeti/HTools/Program/Hinfo.hs \
430 7b695a0d Iustin Pop
	htools/Ganeti/HTools/Program/Hscan.hs \
431 1494a4cc Iustin Pop
	htools/Ganeti/HTools/Program/Hspace.hs \
432 0c37d1e4 Iustin Pop
	htools/Ganeti/BasicTypes.hs \
433 51000365 Iustin Pop
	htools/Ganeti/Common.hs \
434 f3baf5ef Iustin Pop
	htools/Ganeti/Compat.hs \
435 417cc253 Iustin Pop
	htools/Ganeti/Confd.hs \
436 358a0a8f Iustin Pop
	htools/Ganeti/Confd/Server.hs \
437 62377cf5 Iustin Pop
	htools/Ganeti/Confd/Utils.hs \
438 eaa64cd8 Iustin Pop
	htools/Ganeti/Config.hs \
439 6ec7a50e Iustin Pop
	htools/Ganeti/Daemon.hs \
440 21dc8694 Iustin Pop
	htools/Ganeti/Hash.hs \
441 d6159933 Iustin Pop
	htools/Ganeti/Jobs.hs \
442 f3baf5ef Iustin Pop
	htools/Ganeti/JSON.hs \
443 ba4e38e8 Iustin Pop
	htools/Ganeti/Logging.hs \
444 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
445 b1e81520 Iustin Pop
	htools/Ganeti/Objects.hs \
446 e9aaa3c6 Iustin Pop
	htools/Ganeti/OpCodes.hs \
447 9eeb0aa5 Michael Hanselmann
	htools/Ganeti/Path.hs \
448 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Common.hs \
449 8a65c02b Iustin Pop
	htools/Ganeti/Query/Filter.hs \
450 40246fa0 Agata Murawska
	htools/Ganeti/Query/Group.hs \
451 4cab6703 Iustin Pop
	htools/Ganeti/Query/Language.hs \
452 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Node.hs \
453 4cbe9bda Iustin Pop
	htools/Ganeti/Query/Query.hs \
454 4cab6703 Iustin Pop
	htools/Ganeti/Query/Server.hs \
455 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Types.hs \
456 4cab6703 Iustin Pop
	htools/Ganeti/Rpc.hs \
457 7946c25d Iustin Pop
	htools/Ganeti/Runtime.hs \
458 aa3adf35 Iustin Pop
	htools/Ganeti/Ssconf.hs \
459 51309138 Iustin Pop
	htools/Ganeti/THH.hs
460 51309138 Iustin Pop
461 51309138 Iustin Pop
HS_TEST_SRCS = \
462 1493a93b Iustin Pop
	htest/Test/Ganeti/BasicTypes.hs \
463 51000365 Iustin Pop
	htest/Test/Ganeti/Common.hs \
464 51000365 Iustin Pop
	htest/Test/Ganeti/Daemon.hs \
465 305e174c Iustin Pop
	htest/Test/Ganeti/Confd/Utils.hs \
466 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/CLI.hs \
467 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Cluster.hs \
468 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Container.hs \
469 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Instance.hs \
470 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Loader.hs \
471 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Node.hs \
472 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/PeerMap.hs \
473 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Simu.hs \
474 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Text.hs \
475 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Types.hs \
476 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Utils.hs \
477 2d87bd0a Iustin Pop
	htest/Test/Ganeti/JSON.hs \
478 2d87bd0a Iustin Pop
	htest/Test/Ganeti/Jobs.hs \
479 aed2325f Iustin Pop
	htest/Test/Ganeti/Luxi.hs \
480 2733df51 Iustin Pop
	htest/Test/Ganeti/Objects.hs \
481 aed2325f Iustin Pop
	htest/Test/Ganeti/OpCodes.hs \
482 90171729 Iustin Pop
	htest/Test/Ganeti/Query/Filter.hs \
483 aed2325f Iustin Pop
	htest/Test/Ganeti/Query/Language.hs \
484 b9bdc10e Iustin Pop
	htest/Test/Ganeti/Query/Query.hs \
485 aed2325f Iustin Pop
	htest/Test/Ganeti/Rpc.hs \
486 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/Ssconf.hs \
487 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestCommon.hs \
488 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestHTools.hs \
489 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestHelper.hs
490 e4cc4c11 Iustin Pop
491 51309138 Iustin Pop
HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
492 d6159933 Iustin Pop
493 b88fcdd0 Iustin Pop
HS_BUILT_SRCS = \
494 b88fcdd0 Iustin Pop
	htest/Test/Ganeti/TestImports.hs \
495 b88fcdd0 Iustin Pop
	htools/Ganeti/Constants.hs \
496 2997cb0a Iustin Pop
	htools/Ganeti/Version.hs
497 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
498 d6159933 Iustin Pop
499 3735787e Iustin Pop
$(RUN_IN_TEMPDIR): | stamp-directories
500 c964d962 Michael Hanselmann
501 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
502 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
503 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
504 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
505 a2d917f3 Iustin Pop
# it changes
506 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
507 7142485a Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
508 7142485a Iustin Pop
	lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
509 08366664 Michael Hanselmann
	| $(BUILT_PYTHON_SOURCES)
510 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
511 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
512 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
513 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
514 13de7d59 Michael Hanselmann
	    -d . \
515 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
516 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
517 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
518 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
519 13de7d59 Michael Hanselmann
	touch $@
520 13de7d59 Michael Hanselmann
521 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
522 2ab2b9f5 Iustin Pop
523 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
524 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
525 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
526 b76aac08 Michael Hanselmann
527 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
528 cbf3d64b Michael Hanselmann
	set -e; \
529 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
530 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
531 cbf3d64b Michael Hanselmann
	  echo; \
532 cbf3d64b Michael Hanselmann
	  cat $<; \
533 cbf3d64b Michael Hanselmann
	} > $@
534 cbf3d64b Michael Hanselmann
535 b8195800 Iustin Pop
docdot = \
536 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
537 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
538 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
539 b8195800 Iustin Pop
540 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
541 e8230860 Michael Hanselmann
542 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
543 7e1ccbe0 Michael Hanselmann
# distributed)
544 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
545 7e1ccbe0 Michael Hanselmann
	devel/upload \
546 7e1ccbe0 Michael Hanselmann
	doc/html \
547 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
548 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
549 e80aeb89 Michael Hanselmann
	doc/examples/bash_completion-debug \
550 7e1ccbe0 Michael Hanselmann
	$(manhtml)
551 f29266b4 Iustin Pop
552 4f3d5b76 Michael Hanselmann
gnt_scripts = \
553 e8230860 Michael Hanselmann
	scripts/gnt-backup \
554 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
555 e8230860 Michael Hanselmann
	scripts/gnt-debug \
556 667dbd6b Adeodato Simo
	scripts/gnt-group \
557 e8230860 Michael Hanselmann
	scripts/gnt-instance \
558 e8230860 Michael Hanselmann
	scripts/gnt-job \
559 e8230860 Michael Hanselmann
	scripts/gnt-node \
560 e8230860 Michael Hanselmann
	scripts/gnt-os
561 e8230860 Michael Hanselmann
562 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP_SBIN = \
563 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
564 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
565 9f4bb951 Michael Hanselmann
	daemons/ganeti-watcher \
566 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
567 656a7fdf Iustin Pop
	$(gnt_scripts)
568 2d48a3a2 Michael Hanselmann
569 73b0fa69 Iustin Pop
if PY_CONFD
570 73b0fa69 Iustin Pop
PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
571 73b0fa69 Iustin Pop
endif
572 73b0fa69 Iustin Pop
573 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP = \
574 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
575 0d2bf835 René Nussbaumer
	tools/ensure-dirs
576 0d2bf835 René Nussbaumer
577 a8c68e44 Michael Hanselmann
qa_scripts = \
578 a0c3e726 Michael Hanselmann
	qa/__init__.py \
579 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
580 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
581 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
582 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
583 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
584 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
585 21bf2e2e Andrea Spadaccini
	qa/qa_group.py \
586 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
587 09470dd8 Michael Hanselmann
	qa/qa_job.py \
588 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
589 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
590 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
591 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
592 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
593 a8c68e44 Michael Hanselmann
594 d6159933 Iustin Pop
bin_SCRIPTS =
595 d6159933 Iustin Pop
if WANT_HTOOLS
596 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
597 458a286a Iustin Pop
install-exec-hook:
598 458a286a Iustin Pop
	@mkdir_p@ $(DESTDIR)$(iallocatorsdir)
599 7fa52acd Iustin Pop
# FIXME: this is a hardcoded logic, instead of auto-resolving
600 7fa52acd Iustin Pop
	$(LN_S) -f ../../../bin/htools \
601 458a286a Iustin Pop
		   $(DESTDIR)$(iallocatorsdir)/hail
602 201b6c34 Iustin Pop
	for role in $(HS_BIN_ROLES); do \
603 7fa52acd Iustin Pop
		$(LN_S) -f htools \
604 201b6c34 Iustin Pop
			   $(DESTDIR)$(bindir)/$$role ; \
605 201b6c34 Iustin Pop
	done
606 73b0fa69 Iustin Pop
if HS_CONFD
607 73b0fa69 Iustin Pop
	mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
608 73b0fa69 Iustin Pop
endif
609 d6159933 Iustin Pop
endif
610 d6159933 Iustin Pop
611 51309138 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
612 16a6192d Iustin Pop
	@if [ -z "$(HTOOLS)" ]; then \
613 16a6192d Iustin Pop
	  echo "Error: htools compilation disabled at configure time" 1>&2 ;\
614 16a6192d Iustin Pop
	  exit 1; \
615 16a6192d Iustin Pop
	fi
616 f0f3a6df Iustin Pop
	@if [ "$(notdir $@)" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
617 fd0bc853 Iustin Pop
	  echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
618 fd0bc853 Iustin Pop
	  exit 1; \
619 49e11c49 Iustin Pop
	fi
620 f0f3a6df Iustin Pop
	@rm -f $(notdir $@).tix
621 f0f3a6df Iustin Pop
	$(GHC) --make \
622 ef958f2a Iustin Pop
	  $(HFLAGS) \
623 1adec4be Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
624 f0f3a6df Iustin Pop
	  -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
625 c7ec3025 Iustin Pop
	  $(HEXTRA) $(HEXTRA_INT) $@
626 70b6c284 Iustin Pop
	@touch "$@"
627 70b6c284 Iustin Pop
628 f0f3a6df Iustin Pop
# for the htest/test binary, we need to enable profiling/coverage
629 f0f3a6df Iustin Pop
htest/test: HEXTRA_INT=-fhpc -ihtest
630 b91e9518 Iustin Pop
631 896b2850 Iustin Pop
# we compile the hpc-htools binary with the program coverage
632 f0f3a6df Iustin Pop
htest/hpc-htools: HEXTRA_INT=-fhpc
633 25cdf177 Iustin Pop
634 04d15e63 Iustin Pop
# test dependency
635 f0f3a6df Iustin Pop
htest/offline-tests.sh: htest/hpc-htools
636 04d15e63 Iustin Pop
637 c7ec3025 Iustin Pop
# rules for building profiling-enabled versions of the haskell
638 c7ec3025 Iustin Pop
# programs: hs-prof does the full two-step build, whereas
639 c7ec3025 Iustin Pop
# hs-prof-quick does only the final rebuild (hs-prof must have been
640 c7ec3025 Iustin Pop
# run before)
641 c7ec3025 Iustin Pop
.PHONY: hs-prof hs-prof-quick
642 c7ec3025 Iustin Pop
hs-prof:
643 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) clean
644 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
645 c7ec3025 Iustin Pop
	rm -f $(HS_ALL_PROGS)
646 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
647 c7ec3025 Iustin Pop
648 c7ec3025 Iustin Pop
hs-prof-quick:
649 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
650 c7ec3025 Iustin Pop
651 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
652 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
653 4f3d5b76 Michael Hanselmann
654 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
655 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
656 2958c56e Michael Hanselmann
	daemons/ganeti-cleaner \
657 2958c56e Michael Hanselmann
	daemons/ganeti-master-cleaner
658 fc3fd894 Michael Hanselmann
659 73b0fa69 Iustin Pop
if HS_CONFD
660 73b0fa69 Iustin Pop
nodist_sbin_SCRIPTS += htools/hconfd
661 73b0fa69 Iustin Pop
endif
662 73b0fa69 Iustin Pop
663 cc120286 Bernardo Dal Seno
python_scripts = \
664 e8230860 Michael Hanselmann
	tools/burnin \
665 e8230860 Michael Hanselmann
	tools/cfgshell \
666 e8230860 Michael Hanselmann
	tools/cfgupgrade \
667 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
668 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
669 4ef0399b Iustin Pop
	tools/confd-client \
670 d62cbd3a Michael Hanselmann
	tools/fmtjson \
671 ea5fd476 Iustin Pop
	tools/lvmstrap \
672 6bf273d5 Michael Hanselmann
	tools/move-instance \
673 ced78a66 Agata Murawska
	tools/ovfconverter \
674 05cd934d René Nussbaumer
	tools/setup-ssh \
675 ea5fd476 Iustin Pop
	tools/sanitize-config
676 e8230860 Michael Hanselmann
677 61631293 Stephen Shirley
dist_tools_SCRIPTS = \
678 cc120286 Bernardo Dal Seno
	$(python_scripts) \
679 2f4c951e Stephen Shirley
	tools/kvm-console-wrapper \
680 d9eefcfa Andrea Spadaccini
	tools/xm-console-wrapper \
681 d9eefcfa Andrea Spadaccini
	tools/master-ip-setup
682 61631293 Stephen Shirley
683 29386d3e Michael Hanselmann
nodist_tools_SCRIPTS = \
684 29386d3e Michael Hanselmann
	tools/vcluster-setup
685 29386d3e Michael Hanselmann
686 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
687 c6ccba7e Michael Hanselmann
	daemons/import-export \
688 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
689 2d76b580 Michael Hanselmann
690 0d2bf835 René Nussbaumer
nodist_pkglib_python_scripts = \
691 0d2bf835 René Nussbaumer
	tools/ensure-dirs
692 0d2bf835 René Nussbaumer
693 b8fe7ca6 Iustin Pop
myexeclib_SCRIPTS = \
694 2d76b580 Michael Hanselmann
	daemons/daemon-util \
695 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
696 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
697 f154a7a3 Michael Hanselmann
698 b8fe7ca6 Iustin Pop
nodist_myexeclib_SCRIPTS = \
699 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts)
700 0d2bf835 René Nussbaumer
701 e8230860 Michael Hanselmann
EXTRA_DIST = \
702 e8230860 Michael Hanselmann
	NEWS \
703 7a03d293 Michael Hanselmann
	UPGRADE \
704 f774bd03 Michael Hanselmann
	epydoc.conf.in \
705 70c771f6 Michael Hanselmann
	pylintrc \
706 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
707 d5a2a550 Michael Hanselmann
	autotools/build-rpc \
708 5d3c30df Michael Hanselmann
	autotools/check-header \
709 eed5c5df Michael Hanselmann
	autotools/check-python-code \
710 f6cbcc06 Michael Hanselmann
	autotools/check-imports \
711 c55cc346 Iustin Pop
	autotools/check-man-dashes \
712 73d0e218 Iustin Pop
	autotools/check-man-warnings \
713 c81ed2b2 Michael Hanselmann
	autotools/check-news \
714 e627fe09 Michael Hanselmann
	autotools/check-tar \
715 96602be4 Michael Hanselmann
	autotools/check-version \
716 d99d1e36 Iustin Pop
	autotools/convert-constants \
717 95eb4188 Michael Hanselmann
	autotools/docpp \
718 27e336af Michael Hanselmann
	autotools/gen-coverage \
719 df69e0a0 Bernardo Dal Seno
	autotools/testrunner \
720 387863a5 Iustin Pop
	autotools/wrong-hardcoded-paths \
721 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
722 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
723 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
724 2958c56e Michael Hanselmann
	daemons/ganeti-master-cleaner.in \
725 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
726 e8230860 Michael Hanselmann
	devel/upload.in \
727 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
728 29386d3e Michael Hanselmann
	tools/vcluster-setup.in \
729 b8195800 Iustin Pop
	$(docdot) \
730 f727d134 Michael Hanselmann
	$(docpng) \
731 d17e74b4 Iustin Pop
	$(docrst) \
732 d17e74b4 Iustin Pop
	doc/conf.py \
733 d17e74b4 Iustin Pop
	doc/html \
734 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES:%=%.in) \
735 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
736 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
737 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
738 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
739 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
740 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
741 e4d452b4 Michael Hanselmann
	test/lockperf.py \
742 e8230860 Michael Hanselmann
	test/testutils.py \
743 e8230860 Michael Hanselmann
	test/mocks.py \
744 e8230860 Michael Hanselmann
	$(dist_TESTS) \
745 e8230860 Michael Hanselmann
	$(TEST_FILES) \
746 6be8e2bf Iustin Pop
	man/footer.rst \
747 6be8e2bf Iustin Pop
	$(manrst) \
748 f727d134 Michael Hanselmann
	$(maninput) \
749 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
750 d6159933 Iustin Pop
	$(qa_scripts) \
751 51309138 Iustin Pop
	$(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
752 5a1e31b4 Iustin Pop
	$(HS_PROG_SRCS) \
753 04d15e63 Iustin Pop
	htools/lint-hints.hs \
754 f0f3a6df Iustin Pop
	htest/cli-tests-defs.sh \
755 f0f3a6df Iustin Pop
	htest/offline-test.sh
756 e8230860 Michael Hanselmann
757 e8230860 Michael Hanselmann
man_MANS = \
758 e8230860 Michael Hanselmann
	man/ganeti.7 \
759 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
760 2958c56e Michael Hanselmann
	man/ganeti-master-cleaner.8 \
761 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
762 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
763 320d986d Iustin Pop
	man/ganeti-masterd.8 \
764 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
765 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
766 320d986d Iustin Pop
	man/ganeti-rapi.8 \
767 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
768 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
769 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
770 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
771 667dbd6b Adeodato Simo
	man/gnt-group.8 \
772 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
773 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
774 e8230860 Michael Hanselmann
	man/gnt-node.8 \
775 5a19bd35 Iustin Pop
	man/gnt-os.8 \
776 5a19bd35 Iustin Pop
	man/hail.1 \
777 5a19bd35 Iustin Pop
	man/hbal.1 \
778 f18e4168 Iustin Pop
	man/hcheck.1 \
779 e2bdaf25 René Nussbaumer
	man/hinfo.1 \
780 5a19bd35 Iustin Pop
	man/hscan.1 \
781 d26d808a Iustin Pop
	man/hspace.1 \
782 d26d808a Iustin Pop
	man/htools.1
783 e8230860 Michael Hanselmann
784 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
785 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
786 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
787 25c92bc5 Michael Hanselmann
maninput = \
788 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
789 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
790 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
791 e8230860 Michael Hanselmann
792 e8230860 Michael Hanselmann
TEST_FILES = \
793 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
794 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
795 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
796 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
797 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
798 27e46076 Michael Hanselmann
	test/data/cert1.pem \
799 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-dummy0.txt \
800 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv4.txt \
801 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv6.txt \
802 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv4.txt \
803 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv6.txt \
804 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline.txt \
805 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo.txt \
806 d816408a Iustin Pop
	test/data/proc_drbd8.txt \
807 a6ac80db Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
808 2d76b580 Michael Hanselmann
	test/data/proc_drbd83.txt \
809 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync.txt \
810 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync_krnl2.6.39.txt \
811 585c8187 Guido Trotter
	test/data/kvm_1.0_help.txt \
812 585c8187 Guido Trotter
	test/data/kvm_0.15.90_help.txt \
813 585c8187 Guido Trotter
	test/data/kvm_0.12.5_help.txt \
814 585c8187 Guido Trotter
	test/data/kvm_0.9.1_help.txt \
815 549071a0 Luca Bigliardi
	test/data/sys_drbd_usermode_helper.txt \
816 1e6fab60 Agata Murawska
	test/data/ovfdata/compr_disk.vmdk.gz \
817 d92518d3 Agata Murawska
	test/data/ovfdata/config.ini \
818 1e6fab60 Agata Murawska
	test/data/ovfdata/corrupted_resources.ovf \
819 d92518d3 Agata Murawska
	test/data/ovfdata/empty.ini \
820 1e6fab60 Agata Murawska
	test/data/ovfdata/empty.ovf \
821 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.mf \
822 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.ovf \
823 1e6fab60 Agata Murawska
	test/data/ovfdata/gzip_disk.ovf \
824 1e6fab60 Agata Murawska
	test/data/ovfdata/new_disk.vmdk \
825 d92518d3 Agata Murawska
	test/data/ovfdata/no_disk.ini \
826 1e6fab60 Agata Murawska
	test/data/ovfdata/no_disk_in_ref.ovf \
827 d92518d3 Agata Murawska
	test/data/ovfdata/no_os.ini \
828 1e6fab60 Agata Murawska
	test/data/ovfdata/no_ovf.ova \
829 1e6fab60 Agata Murawska
	test/data/ovfdata/ova.ova \
830 1e6fab60 Agata Murawska
	test/data/ovfdata/second_disk.vmdk \
831 d92518d3 Agata Murawska
	test/data/ovfdata/rawdisk.raw \
832 d92518d3 Agata Murawska
	test/data/ovfdata/unsafe_path.ini \
833 1e6fab60 Agata Murawska
	test/data/ovfdata/virtualbox.ovf \
834 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_extension.ovd \
835 d92518d3 Agata Murawska
	test/data/ovfdata/wrong_config.ini \
836 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.mf \
837 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.ovf \
838 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_ova.ova \
839 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_xml.ovf \
840 d92518d3 Agata Murawska
	test/data/ovfdata/other/rawdisk.raw \
841 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.02.txt \
842 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-fail.txt \
843 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-ok.txt \
844 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.02.txt \
845 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.66.txt \
846 53d4cdf1 Iustin Pop
	test/import-export_unittest-helper \
847 30f2802f Iustin Pop
	test/gnt-cli.test \
848 30f2802f Iustin Pop
	test/ganeti-cli.test \
849 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-balancing.test \
850 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-basic.test \
851 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-dynutil.test \
852 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-excl.test \
853 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-hail.test \
854 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-hspace.test \
855 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-invalid.test \
856 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-multi-group.test \
857 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-no-backend.test \
858 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-rapi.test \
859 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-single-group.test \
860 b8a9c7f2 Iustin Pop
	htest/shelltests/htools-text-backend.test \
861 8feabc89 Iustin Pop
	htest/data/hail-alloc-drbd.json \
862 8feabc89 Iustin Pop
	htest/data/hail-change-group.json \
863 8feabc89 Iustin Pop
	htest/data/hail-invalid-reloc.json \
864 8feabc89 Iustin Pop
	htest/data/hail-node-evac.json \
865 8feabc89 Iustin Pop
	htest/data/hail-reloc-drbd.json \
866 8feabc89 Iustin Pop
	htest/data/hbal-split-insts.data \
867 8feabc89 Iustin Pop
	htest/data/common-suffix.data \
868 8feabc89 Iustin Pop
	htest/data/invalid-node.data \
869 8feabc89 Iustin Pop
	htest/data/missing-resources.data \
870 8feabc89 Iustin Pop
	htest/data/rapi/groups.json \
871 8feabc89 Iustin Pop
	htest/data/rapi/info.json \
872 8feabc89 Iustin Pop
	htest/data/rapi/instances.json \
873 8feabc89 Iustin Pop
	htest/data/rapi/nodes.json
874 e8230860 Michael Hanselmann
875 e8c8cf1a Michael Hanselmann
python_tests = \
876 3ade0e0e Michael Hanselmann
	doc/examples/rapi_testutils.py \
877 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
878 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
879 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
880 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
881 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
882 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
883 1118ec44 Guido Trotter
	test/ganeti.daemon_unittest.py \
884 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
885 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
886 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
887 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
888 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
889 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
890 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
891 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
892 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
893 b7d82e40 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
894 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
895 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
896 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
897 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
898 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
899 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
900 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
901 6f1aa78d Michael Hanselmann
	test/ganeti.jstore_unittest.py \
902 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
903 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
904 33b4fa9f René Nussbaumer
	test/ganeti.masterd.iallocator_unittest.py \
905 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
906 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
907 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
908 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
909 32683096 René Nussbaumer
	test/ganeti.objectutils_unittest.py \
910 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
911 1e6fab60 Agata Murawska
	test/ganeti.ovf_unittest.py \
912 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
913 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
914 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
915 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
916 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
917 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
918 a85f23fa Michael Hanselmann
	test/ganeti.rapi.testutils_unittest.py \
919 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
920 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
921 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
922 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
923 048eeb2b Iustin Pop
	test/ganeti.storage_unittest.py \
924 0d2bf835 René Nussbaumer
	test/ganeti.tools.ensure_dirs_unittest.py \
925 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
926 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
927 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
928 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
929 3865ca48 Michael Hanselmann
	test/ganeti.utils.io_unittest.py \
930 7ebadeb3 Bernardo Dal Seno
	test/ganeti.utils.io_unittest-runasroot.py \
931 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
932 8dc76d54 Guido Trotter
	test/ganeti.utils.mlock_unittest.py \
933 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
934 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
935 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
936 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
937 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
938 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
939 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
940 05e733b4 Michael Hanselmann
	test/ganeti.vcluster_unittest.py \
941 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
942 a0c3e726 Michael Hanselmann
	test/qa.qa_config_unittest.py \
943 aefbe369 Michael Hanselmann
	test/cfgupgrade_unittest.py \
944 055f822b Michael Hanselmann
	test/docs_unittest.py \
945 4fd2660d Michael Hanselmann
	test/pycurl_reset_unittest.py \
946 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
947 e8230860 Michael Hanselmann
948 f0f3a6df Iustin Pop
haskell_tests = htest/test
949 b91e9518 Iustin Pop
950 e8c8cf1a Michael Hanselmann
dist_TESTS = \
951 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
952 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
953 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
954 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
955 30f2802f Iustin Pop
	test/cli-test.bash \
956 92886204 Michael Hanselmann
	test/bash_completion.bash \
957 e8c8cf1a Michael Hanselmann
	$(python_tests)
958 e8c8cf1a Michael Hanselmann
959 e8230860 Michael Hanselmann
nodist_TESTS =
960 d3cd5a3f Iustin Pop
check_SCRIPTS =
961 d3cd5a3f Iustin Pop
962 e5f6768c Iustin Pop
if WANT_HTOOLSTESTS
963 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
964 f0f3a6df Iustin Pop
dist_TESTS += htest/offline-test.sh
965 f0f3a6df Iustin Pop
check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
966 b91e9518 Iustin Pop
endif
967 e8230860 Michael Hanselmann
968 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
969 e8230860 Michael Hanselmann
970 27e336af Michael Hanselmann
# Environment for all tests
971 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
972 30f2802f Iustin Pop
	PYTHONPATH=. \
973 30f2802f Iustin Pop
	TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
974 30f2802f Iustin Pop
	PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
975 30f2802f Iustin Pop
	$(RUN_IN_TEMPDIR)
976 27e336af Michael Hanselmann
977 27e336af Michael Hanselmann
# Environment for tests run by automake
978 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
979 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
980 6e06b36c Iustin Pop
981 eed5c5df Michael Hanselmann
all_python_code = \
982 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
983 cc120286 Bernardo Dal Seno
	$(python_scripts) \
984 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
985 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts) \
986 e8c8cf1a Michael Hanselmann
	$(python_tests) \
987 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
988 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
989 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
990 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
991 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
992 0d2bf835 René Nussbaumer
	$(pytools_PYTHON) \
993 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
994 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
995 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
996 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
997 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
998 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
999 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
1000 a8c68e44 Michael Hanselmann
	$(qa_scripts)
1001 01a3a718 Michael Hanselmann
1002 eed5c5df Michael Hanselmann
srclink_files = \
1003 6be8e2bf Iustin Pop
	man/footer.rst \
1004 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
1005 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
1006 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
1007 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
1008 30f2802f Iustin Pop
	test/cli-test.bash \
1009 92886204 Michael Hanselmann
	test/bash_completion.bash \
1010 f0f3a6df Iustin Pop
	htest/offline-test.sh \
1011 f0f3a6df Iustin Pop
	htest/cli-tests-defs.sh \
1012 d6159933 Iustin Pop
	$(all_python_code) \
1013 51309138 Iustin Pop
	$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1014 eed5c5df Michael Hanselmann
1015 eed5c5df Michael Hanselmann
check_python_code = \
1016 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
1017 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
1018 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1019 95eb4188 Michael Hanselmann
	$(DOCPP) \
1020 eed5c5df Michael Hanselmann
	$(all_python_code)
1021 eed5c5df Michael Hanselmann
1022 e4e7c7df Michael Hanselmann
lint_python_code = \
1023 f60d352e Michael Hanselmann
	ganeti \
1024 f1763373 Iustin Pop
	ganeti/http/server.py \
1025 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
1026 cc120286 Bernardo Dal Seno
	$(python_scripts) \
1027 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
1028 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
1029 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
1030 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1031 95eb4188 Michael Hanselmann
	$(DOCPP) \
1032 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
1033 eed5c5df Michael Hanselmann
1034 f6cbcc06 Michael Hanselmann
standalone_python_modules = \
1035 f6cbcc06 Michael Hanselmann
	lib/rapi/client.py \
1036 f6cbcc06 Michael Hanselmann
	tools/ganeti-listrunner
1037 f6cbcc06 Michael Hanselmann
1038 21bf2e2e Andrea Spadaccini
pep8_python_code = \
1039 21bf2e2e Andrea Spadaccini
	ganeti \
1040 21bf2e2e Andrea Spadaccini
	ganeti/http/server.py \
1041 21bf2e2e Andrea Spadaccini
	$(dist_sbin_SCRIPTS) \
1042 cc120286 Bernardo Dal Seno
	$(python_scripts) \
1043 21bf2e2e Andrea Spadaccini
	$(pkglib_python_scripts) \
1044 21bf2e2e Andrea Spadaccini
	$(BUILD_BASH_COMPLETION) \
1045 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1046 21bf2e2e Andrea Spadaccini
	$(DOCPP) \
1047 21bf2e2e Andrea Spadaccini
	$(PYTHON_BOOTSTRAP) \
1048 21bf2e2e Andrea Spadaccini
	qa
1049 21bf2e2e Andrea Spadaccini
1050 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
1051 571b34f8 Michael Hanselmann
1052 2958c56e Michael Hanselmann
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner \
1053 2958c56e Michael Hanselmann
  daemons/ganeti-master-cleaner
1054 7172f605 Michael Hanselmann
1055 92886204 Michael Hanselmann
test/bash_completion.bash: doc/examples/bash_completion-debug
1056 92886204 Michael Hanselmann
1057 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1058 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
1059 26916aad Apollon Oikonomopoulos
	chmod +x $@
1060 26916aad Apollon Oikonomopoulos
1061 dbefcc7e Michael Hanselmann
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
1062 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1063 e8230860 Michael Hanselmann
	chmod u+x $@
1064 e8230860 Michael Hanselmann
1065 29386d3e Michael Hanselmann
tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1066 29386d3e Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1067 29386d3e Michael Hanselmann
	chmod +x $@
1068 29386d3e Michael Hanselmann
1069 490bec02 Iustin Pop
daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1070 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1071 5c566e17 Michael Hanselmann
	chmod +x $@
1072 e8230860 Michael Hanselmann
1073 490bec02 Iustin Pop
doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1074 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1075 e8230860 Michael Hanselmann
1076 e80aeb89 Michael Hanselmann
doc/examples/bash_completion: BC_ARGS = --compact
1077 e80aeb89 Michael Hanselmann
doc/examples/bash_completion-debug: BC_ARGS =
1078 e80aeb89 Michael Hanselmann
1079 e80aeb89 Michael Hanselmann
doc/examples/bash_completion doc/examples/bash_completion-debug: \
1080 e80aeb89 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1081 4c3d5fb6 Iustin Pop
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1082 ada0e680 Iustin Pop
	$(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1083 e80aeb89 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1084 e80aeb89 Michael Hanselmann
	  $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1085 4f3d5b76 Michael Hanselmann
1086 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
1087 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1088 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
1089 f86e82ef Iustin Pop
1090 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
1091 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
1092 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1093 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
1094 de8eea3e Iustin Pop
1095 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
1096 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1097 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1098 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
1099 6be8e2bf Iustin Pop
1100 7142485a Iustin Pop
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1101 d7772efa Iustin Pop
	lib/build/shell_example_lexer.py \
1102 a13d6911 Iustin Pop
	| $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1103 387863a5 Iustin Pop
	@echo "Checking $< for hardcoded paths..."
1104 387863a5 Iustin Pop
	@if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1105 387863a5 Iustin Pop
	  echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1106 387863a5 Iustin Pop
	  exit 1; \
1107 387863a5 Iustin Pop
	fi
1108 a13d6911 Iustin Pop
	set -e ; \
1109 a13d6911 Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1110 a13d6911 Iustin Pop
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1111 a13d6911 Iustin Pop
	trap - EXIT
1112 fcdb582d Michael Hanselmann
1113 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1114 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1115 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1116 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1117 9c45babb Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1118 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1119 9c45babb Iustin Pop
	  sed -e 's/\\@/@/g' > $@; \
1120 73d0e218 Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1121 c55cc346 Iustin Pop
	$(CHECK_MAN_DASHES) $@; \
1122 9c45babb Iustin Pop
	trap - EXIT
1123 9c45babb Iustin Pop
1124 2ab2b9f5 Iustin Pop
1125 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
1126 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1127 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1128 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1129 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1130 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
1131 6be8e2bf Iustin Pop
1132 55398706 Iustin Pop
man/%: man/%.in  $(REPLACE_VARS_SED)
1133 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1134 f29266b4 Iustin Pop
1135 fc1282b8 Iustin Pop
epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1136 fc1282b8 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1137 f774bd03 Michael Hanselmann
1138 84a12e40 Iustin Pop
vcs-version:
1139 84a12e40 Iustin Pop
	if test -d .git; then \
1140 84a12e40 Iustin Pop
	  git describe > $@; \
1141 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
1142 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
1143 84a12e40 Iustin Pop
	fi
1144 84a12e40 Iustin Pop
1145 316dc1ff Iustin Pop
.PHONY: clean-vcs-version
1146 316dc1ff Iustin Pop
clean-vcs-version:
1147 316dc1ff Iustin Pop
	rm -f vcs-version
1148 316dc1ff Iustin Pop
1149 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
1150 84a12e40 Iustin Pop
regen-vcs-version:
1151 e8230860 Michael Hanselmann
	set -e; \
1152 84a12e40 Iustin Pop
	cd $(srcdir); \
1153 84a12e40 Iustin Pop
	if test -d .git; then \
1154 b0b8458a Iustin Pop
	  $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
1155 b0b8458a Iustin Pop
	  $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
1156 84a12e40 Iustin Pop
	fi
1157 84a12e40 Iustin Pop
1158 2997cb0a Iustin Pop
htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1159 4c3d5fb6 Iustin Pop
	vcs-version $(built_base_sources)
1160 d6159933 Iustin Pop
	set -e; \
1161 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1162 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
1163 d6159933 Iustin Pop
1164 d99d1e36 Iustin Pop
htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1165 f11e524b Iustin Pop
	lib/constants.py lib/_autoconf.py lib/luxi.py \
1166 4c3d5fb6 Iustin Pop
	$(CONVERT_CONSTANTS) $(built_base_sources) \
1167 ef958f2a Iustin Pop
	| lib/_vcsversion.py
1168 11fd5a86 Iustin Pop
	set -e; \
1169 876f6a5e Iustin Pop
	{ cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1170 d99d1e36 Iustin Pop
1171 b88fcdd0 Iustin Pop
htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1172 b88fcdd0 Iustin Pop
	$(built_base_sources)
1173 b88fcdd0 Iustin Pop
	set -e; \
1174 b88fcdd0 Iustin Pop
	{ cat $< ; \
1175 b88fcdd0 Iustin Pop
	  echo ; \
1176 b88fcdd0 Iustin Pop
	  for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1177 b88fcdd0 Iustin Pop
	    echo "import $$name ()" ; \
1178 b88fcdd0 Iustin Pop
	  done ; \
1179 b88fcdd0 Iustin Pop
	} > $@
1180 b88fcdd0 Iustin Pop
1181 3735787e Iustin Pop
lib/_autoconf.py: Makefile | stamp-directories
1182 84a12e40 Iustin Pop
	set -e; \
1183 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
1184 e8230860 Michael Hanselmann
	  echo '#'; \
1185 67047322 Iustin Pop
	  echo ''; \
1186 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
1187 67047322 Iustin Pop
	  echo '';\
1188 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1189 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1190 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
1191 67047322 Iustin Pop
	  echo ''; \
1192 67047322 Iustin Pop
	  echo '"""'; \
1193 67047322 Iustin Pop
	  echo ''; \
1194 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1195 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1196 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
1197 0a4e7f24 Iustin Pop
	  echo ''; \
1198 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1199 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1200 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1201 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1202 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1203 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1204 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1205 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
1206 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1207 052783ff Michael Hanselmann
	  echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1208 052783ff Michael Hanselmann
	  echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1209 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1210 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1211 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1212 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1213 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1214 b8203e1e Iustin Pop
	  echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1215 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1216 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1217 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1218 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1219 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1220 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
1221 c4dfb0b6 Andrea Spadaccini
	  echo "IP_PATH = '$(IP_PATH)'"; \
1222 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
1223 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1224 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1225 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1226 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
1227 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1228 ada0e680 Iustin Pop
	  echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1229 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
1230 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1231 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1232 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1233 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1234 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1235 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1236 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1237 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
1238 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1239 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
1240 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1241 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
1242 03881cb0 René Nussbaumer
	  echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1243 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1244 a002ed79 Agata Murawska
	  echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1245 e5395072 Iustin Pop
	  if [ "$(HTOOLS)" ]; then \
1246 e5395072 Iustin Pop
	    echo "HTOOLS = True"; \
1247 e5395072 Iustin Pop
	  else \
1248 e5395072 Iustin Pop
	    echo "HTOOLS = False"; \
1249 e5395072 Iustin Pop
	  fi; \
1250 cd8b0072 Iustin Pop
	  echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1251 73b0fa69 Iustin Pop
	  echo "PY_CONFD = $(PY_CONFD)"; \
1252 73b0fa69 Iustin Pop
	  echo "HS_CONFD = $(HS_CONFD)"; \
1253 1eb37421 René Nussbaumer
	  echo "XEN_CMD = '$(XEN_CMD)'"; \
1254 42ab9ac4 Iustin Pop
	  echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1255 e8230860 Michael Hanselmann
	} > $@
1256 e8230860 Michael Hanselmann
1257 3735787e Iustin Pop
lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1258 13aeae6a Iustin Pop
	set -e; \
1259 13aeae6a Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1260 13aeae6a Iustin Pop
	{ echo '# This file is automatically generated, do not edit!'; \
1261 13aeae6a Iustin Pop
	  echo '#'; \
1262 13aeae6a Iustin Pop
	  echo ''; \
1263 13aeae6a Iustin Pop
	  echo '"""Build-time VCS version number for Ganeti.'; \
1264 13aeae6a Iustin Pop
	  echo '';\
1265 13aeae6a Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1266 13aeae6a Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1267 13aeae6a Iustin Pop
	  echo 'not edit by hand).'; \
1268 13aeae6a Iustin Pop
	  echo ''; \
1269 13aeae6a Iustin Pop
	  echo '"""'; \
1270 13aeae6a Iustin Pop
	  echo ''; \
1271 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1272 13aeae6a Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1273 13aeae6a Iustin Pop
	  echo '# style warnings' ; \
1274 13aeae6a Iustin Pop
	  echo ''; \
1275 13aeae6a Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
1276 13aeae6a Iustin Pop
	} > $@
1277 13aeae6a Iustin Pop
1278 96a7481d Michael Hanselmann
lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1279 96a7481d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1280 d5a2a550 Michael Hanselmann
1281 6e3bf290 Michael Hanselmann
$(SHELL_ENV_INIT): Makefile stamp-directories
1282 6e3bf290 Michael Hanselmann
	set -e; \
1283 6e3bf290 Michael Hanselmann
	{ echo '# Allow overriding for tests'; \
1284 6e3bf290 Michael Hanselmann
	  echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1285 6e3bf290 Michael Hanselmann
	  echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1286 6e3bf290 Michael Hanselmann
	  echo; \
1287 6e3bf290 Michael Hanselmann
	  echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1288 6e3bf290 Michael Hanselmann
	  echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1289 6e3bf290 Michael Hanselmann
	  echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1290 6e3bf290 Michael Hanselmann
	  echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1291 6e3bf290 Michael Hanselmann
	  echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1292 6e3bf290 Michael Hanselmann
	} > $@
1293 6e3bf290 Michael Hanselmann
1294 6e3bf290 Michael Hanselmann
$(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1295 e8230860 Michael Hanselmann
	set -e; \
1296 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
1297 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1298 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1299 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
1300 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
1301 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1302 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1303 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1304 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1305 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1306 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1307 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1308 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1309 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1310 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1311 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1312 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1313 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1314 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1315 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1316 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1317 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1318 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1319 cd8b0072 Iustin Pop
	  echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1320 fc1282b8 Iustin Pop
	  echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1321 42ab9ac4 Iustin Pop
	  echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1322 6e3bf290 Michael Hanselmann
	  echo; \
1323 6e3bf290 Michael Hanselmann
	  echo '/^@SHELL_ENV_INIT@$$/ {'; \
1324 6e3bf290 Michael Hanselmann
	  echo '  r $(SHELL_ENV_INIT)'; \
1325 6e3bf290 Michael Hanselmann
	  echo '  d'; \
1326 6e3bf290 Michael Hanselmann
	  echo '}'; \
1327 e8230860 Michael Hanselmann
	} > $@
1328 e8230860 Michael Hanselmann
1329 67313146 Michael Hanselmann
# Using deferred evaluation
1330 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1331 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
1332 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1333 0d2bf835 René Nussbaumer
tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1334 189b51fa Iustin Pop
$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1335 67313146 Michael Hanselmann
1336 3735787e Iustin Pop
$(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1337 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
1338 2d48a3a2 Michael Hanselmann
	set -e; \
1339 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
1340 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
1341 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
1342 2d48a3a2 Michael Hanselmann
	  echo; \
1343 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1344 2d48a3a2 Michael Hanselmann
	  echo; \
1345 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0103'; \
1346 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
1347 2d48a3a2 Michael Hanselmann
	  echo; \
1348 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
1349 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
1350 2d48a3a2 Michael Hanselmann
	  echo; \
1351 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
1352 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
1353 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
1354 55766d34 Andrea Spadaccini
	  echo '  commands = main.commands # pylint: disable=E1101'; \
1355 3f42b4f6 Michael Hanselmann
	  echo 'if hasattr(main, "aliases"):'; \
1356 55766d34 Andrea Spadaccini
	  echo '  aliases = main.aliases # pylint: disable=E1101'; \
1357 2d48a3a2 Michael Hanselmann
	  echo; \
1358 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
1359 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
1360 2d48a3a2 Michael Hanselmann
	} > $@
1361 2d48a3a2 Michael Hanselmann
	chmod u+x $@
1362 2d48a3a2 Michael Hanselmann
1363 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): Makefile
1364 3096524e Iustin Pop
	@test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1365 3096524e Iustin Pop
	set -e; \
1366 3096524e Iustin Pop
	{ echo '#!/bin/sh'; \
1367 3096524e Iustin Pop
	  echo '# This file is automatically generated, do not edit!'; \
1368 3096524e Iustin Pop
	  echo "# Edit Makefile.am instead."; \
1369 3096524e Iustin Pop
	  echo; \
1370 f0f3a6df Iustin Pop
	  echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1371 3096524e Iustin Pop
	} > $@
1372 3096524e Iustin Pop
	chmod u+x $@
1373 3096524e Iustin Pop
1374 3735787e Iustin Pop
stamp-directories: Makefile
1375 924ecd85 Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) ganeti
1376 3735787e Iustin Pop
	@mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1377 3735787e Iustin Pop
	touch $@
1378 3735787e Iustin Pop
1379 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
1380 e8230860 Michael Hanselmann
# files when building.
1381 3735787e Iustin Pop
stamp-srclinks: Makefile | stamp-directories
1382 e8230860 Michael Hanselmann
	set -e; \
1383 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
1384 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1385 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
1386 e8230860 Michael Hanselmann
		fi; \
1387 e8230860 Michael Hanselmann
	done
1388 dd1dfd9a Michael Hanselmann
	touch $@
1389 97a37b3f Michael Hanselmann
1390 9ff7e35c Michael Hanselmann
.PHONY: ganeti
1391 9ff7e35c Michael Hanselmann
ganeti:
1392 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1393 9ff7e35c Michael Hanselmann
1394 6b997854 Michael Hanselmann
.PHONY: check-dirs
1395 4c3d5fb6 Iustin Pop
check-dirs: $(GENERATED_FILES)
1396 0c1103d6 Iustin Pop
	@set -e; \
1397 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
1398 6b997854 Michael Hanselmann
		-name .git -o \
1399 6b997854 Michael Hanselmann
		-name autom4te.cache \
1400 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
1401 6b997854 Michael Hanselmann
		error=; \
1402 6b997854 Michael Hanselmann
		while read dir; do \
1403 6b997854 Michael Hanselmann
			case "$$dir" in \
1404 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1405 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1406 6b997854 Michael Hanselmann
			esac; \
1407 6b997854 Michael Hanselmann
		done; \
1408 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
1409 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
1410 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
1411 6b997854 Michael Hanselmann
				error=1; \
1412 6b997854 Michael Hanselmann
			fi \
1413 6b997854 Michael Hanselmann
		done; \
1414 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
1415 6b997854 Michael Hanselmann
	}
1416 6b997854 Michael Hanselmann
1417 f6cbcc06 Michael Hanselmann
.PHONY: check-local
1418 4c3d5fb6 Iustin Pop
check-local: check-dirs $(GENERATED_FILES)
1419 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
1420 5d3c30df Michael Hanselmann
	PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1421 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1422 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
1423 83ea5145 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1424 9488fd1d Michael Hanselmann
	expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1425 154d7ba5 Michael Hanselmann
	if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1426 9488fd1d Michael Hanselmann
		echo "Incorrect version in README, expected $$expver"; \
1427 9488fd1d Michael Hanselmann
		exit 1; \
1428 7ecb3d0e Michael Hanselmann
	fi; \
1429 d5114fa1 Michael Hanselmann
	for file in doc/iallocator.rst doc/hooks.rst; do \
1430 d5114fa1 Michael Hanselmann
		if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1431 9822b1dd Iustin Pop
			"Documents Ganeti version $$expver"; then \
1432 d5114fa1 Michael Hanselmann
			echo "Incorrect version in $$file, expected $$expver"; \
1433 d5114fa1 Michael Hanselmann
			exit 1; \
1434 d5114fa1 Michael Hanselmann
		fi; \
1435 d5114fa1 Michael Hanselmann
	done
1436 eed5c5df Michael Hanselmann
1437 49e11c49 Iustin Pop
.PHONY: hs-check
1438 f0f3a6df Iustin Pop
hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1439 49e11c49 Iustin Pop
	@rm -f test.tix
1440 f0f3a6df Iustin Pop
	./htest/test
1441 f0f3a6df Iustin Pop
	HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1442 49e11c49 Iustin Pop
1443 08366664 Michael Hanselmann
# E111: indentation is not a multiple of four
1444 5ae4945a Iustin Pop
# E121: continuation line indentation is not a multiple of four
1445 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1446 5ae4945a Iustin Pop
# E125: continuation line does not distinguish itself from next logical line
1447 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1448 5ae4945a Iustin Pop
# E127: continuation line over-indented for visual indent
1449 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1450 5ae4945a Iustin Pop
# note: do NOT add E128 here; it's a valid style error in most cases!
1451 5ae4945a Iustin Pop
# I've seen real errors, but also some cases were we indent wrongly
1452 5ae4945a Iustin Pop
# due to line length; try to rework the cases where it is triggered,
1453 5ae4945a Iustin Pop
# instead of silencing it
1454 08366664 Michael Hanselmann
# E261: at least two spaces before inline comment
1455 08366664 Michael Hanselmann
# E501: line too long (80 characters)
1456 5ae4945a Iustin Pop
PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1457 08366664 Michael Hanselmann
1458 08366664 Michael Hanselmann
# For excluding pep8 expects filenames only, not whole paths
1459 08366664 Michael Hanselmann
PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1460 08366664 Michael Hanselmann
1461 6e4c8f68 Iustin Pop
LINT_TARGETS = pylint pylint-qa
1462 6e4c8f68 Iustin Pop
if HAS_PEP8
1463 6e4c8f68 Iustin Pop
LINT_TARGETS += pep8
1464 6e4c8f68 Iustin Pop
endif
1465 6e4c8f68 Iustin Pop
if HAS_HLINT
1466 6e4c8f68 Iustin Pop
LINT_TARGETS += hlint
1467 6e4c8f68 Iustin Pop
endif
1468 6e4c8f68 Iustin Pop
1469 e0098923 Iustin Pop
.PHONY: lint
1470 6e4c8f68 Iustin Pop
lint: $(LINT_TARGETS)
1471 6e4c8f68 Iustin Pop
1472 6e4c8f68 Iustin Pop
.PHONY: pylint
1473 4c3d5fb6 Iustin Pop
pylint: $(GENERATED_FILES)
1474 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1475 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
1476 6e4c8f68 Iustin Pop
1477 6e4c8f68 Iustin Pop
.PHONY: pylint-qa
1478 4c3d5fb6 Iustin Pop
pylint-qa: $(GENERATED_FILES)
1479 6e4c8f68 Iustin Pop
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1480 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
1481 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1482 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1483 e0098923 Iustin Pop
1484 6e4c8f68 Iustin Pop
.PHONY: pep8
1485 4c3d5fb6 Iustin Pop
pep8: $(GENERATED_FILES)
1486 6e4c8f68 Iustin Pop
	@test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1487 6e4c8f68 Iustin Pop
	$(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1488 6e4c8f68 Iustin Pop
		--repeat $(pep8_python_code)
1489 6e4c8f68 Iustin Pop
1490 2cdaf225 Iustin Pop
# FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1491 191ff68c Iustin Pop
.PHONY: hlint
1492 5a1e31b4 Iustin Pop
hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1493 6e4c8f68 Iustin Pop
	@test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1494 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
1495 6e4c8f68 Iustin Pop
	$(HLINT) --report=doc/hs-lint.html --cross $$C \
1496 3603605a Iustin Pop
	  --ignore "Use first" \
1497 3603605a Iustin Pop
	  --ignore "Use comparing" \
1498 3603605a Iustin Pop
	  --ignore "Use on" \
1499 3603605a Iustin Pop
	  --ignore "Reduce duplication" \
1500 2cdaf225 Iustin Pop
	  --ignore "Use &&&" \
1501 2cdaf225 Iustin Pop
	  --ignore "Use void" \
1502 5a1e31b4 Iustin Pop
	  --hint htools/lint-hints \
1503 51309138 Iustin Pop
	  $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS))
1504 191ff68c Iustin Pop
1505 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
1506 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
1507 84a12e40 Iustin Pop
dist-hook:
1508 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1509 316dc1ff Iustin Pop
	rm -f $(top_distdir)/vcs-version
1510 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
1511 84a12e40 Iustin Pop
1512 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
1513 b6f2e47f Iustin Pop
distcheck-hook:
1514 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1515 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
1516 c6aa0c42 Michael Hanselmann
		exit 1; \
1517 c6aa0c42 Michael Hanselmann
	fi
1518 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
1519 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
1520 c6aa0c42 Michael Hanselmann
		exit 1; \
1521 c6aa0c42 Michael Hanselmann
	fi
1522 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
1523 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
1524 b6f2e47f Iustin Pop
		exit 1; \
1525 b6f2e47f Iustin Pop
	fi
1526 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
1527 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
1528 bf0b21da Michael Hanselmann
# distcheck must be excluded.
1529 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
1530 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
1531 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
1532 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
1533 bf0b21da Michael Hanselmann
		exit 1; \
1534 bf0b21da Michael Hanselmann
	fi
1535 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
1536 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1537 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
1538 c7b86f6c Michael Hanselmann
		exit 1; \
1539 c7b86f6c Michael Hanselmann
	fi
1540 c7b86f6c Michael Hanselmann
1541 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1542 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1543 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1544 b6f2e47f Iustin Pop
1545 7213dded René Nussbaumer
distrebuildcheck: dist
1546 7213dded René Nussbaumer
	set -e; \
1547 7213dded René Nussbaumer
	builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1548 7213dded René Nussbaumer
	trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1549 7213dded René Nussbaumer
	cd $$builddir; \
1550 7213dded René Nussbaumer
	tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1551 7213dded René Nussbaumer
	cd $(distdir); \
1552 7213dded René Nussbaumer
	./configure; \
1553 7213dded René Nussbaumer
	$(MAKE) maintainer-clean; \
1554 7213dded René Nussbaumer
	cp $(abs_srcdir)/vcs-version .; \
1555 7213dded René Nussbaumer
	./configure; \
1556 7213dded René Nussbaumer
	$(MAKE) $(AM_MAKEFLAGS)
1557 7213dded René Nussbaumer
1558 e627fe09 Michael Hanselmann
dist-release: dist
1559 e627fe09 Michael Hanselmann
	set -e; \
1560 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1561 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1562 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1563 e627fe09 Michael Hanselmann
		echo OK; \
1564 e627fe09 Michael Hanselmann
	done
1565 e627fe09 Michael Hanselmann
1566 8925faaa Iustin Pop
install-exec-local:
1567 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1568 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1569 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1570 e8230860 Michael Hanselmann
1571 d128fdb6 Iustin Pop
.PHONY: apidoc
1572 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1573 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1574 a38bfce5 Iustin Pop
else
1575 a38bfce5 Iustin Pop
apidoc: py-apidoc
1576 a38bfce5 Iustin Pop
endif
1577 a38bfce5 Iustin Pop
1578 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1579 4c3d5fb6 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1580 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1581 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1582 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1583 a38bfce5 Iustin Pop
1584 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1585 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1586 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1587 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1588 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1589 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1590 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1591 458a286a Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1592 358a0a8f Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1593 4cbe9bda Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1594 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1595 82888134 Michael Hanselmann
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1596 358a0a8f Iustin Pop
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1597 a38bfce5 Iustin Pop
	set -e ; \
1598 a38bfce5 Iustin Pop
	cd htools; \
1599 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1600 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1601 c478f837 Iustin Pop
	else OPTGHC=""; \
1602 c478f837 Iustin Pop
	fi; \
1603 1adec4be Iustin Pop
	if [ "$(HTOOLS_PARALLEL3)" ]; \
1604 1adec4be Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1605 1adec4be Iustin Pop
	fi; \
1606 b88fcdd0 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1607 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1608 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1609 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1610 a38bfce5 Iustin Pop
	done ; \
1611 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1612 a38bfce5 Iustin Pop
		-t ganeti-htools -p haddock-prologue \
1613 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1614 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1615 c478f837 Iustin Pop
		$$OPTGHC \
1616 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1617 d128fdb6 Iustin Pop
1618 13e720f1 Iustin Pop
.PHONY: TAGS
1619 4c3d5fb6 Iustin Pop
TAGS: $(GENERATED_FILES)
1620 13e720f1 Iustin Pop
	rm -f TAGS
1621 51309138 Iustin Pop
	$(GHC) -e ":etags" -v0 $(HFLAGS) $(HS_LIBTEST_SRCS)
1622 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1623 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1624 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1625 2db53645 Iustin Pop
	  etags -l python -a -
1626 13e720f1 Iustin Pop
1627 27e336af Michael Hanselmann
.PHONY: coverage
1628 b91e9518 Iustin Pop
if WANT_HTOOLS
1629 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1630 b91e9518 Iustin Pop
else
1631 b91e9518 Iustin Pop
coverage: py-coverage
1632 b91e9518 Iustin Pop
endif
1633 b91e9518 Iustin Pop
1634 b91e9518 Iustin Pop
.PHONY: py-coverage
1635 4c3d5fb6 Iustin Pop
py-coverage: $(GENERATED_FILES) $(python_tests)
1636 27e336af Michael Hanselmann
	set -e; \
1637 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1638 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1639 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1640 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1641 e8c8cf1a Michael Hanselmann
	$(python_tests)
1642 27e336af Michael Hanselmann
1643 b91e9518 Iustin Pop
.PHONY: hs-coverage
1644 f0f3a6df Iustin Pop
hs-coverage: $(haskell_tests) htest/hpc-htools
1645 316dc1ff Iustin Pop
	rm -f *.tix
1646 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) hs-check
1647 48f12e73 Iustin Pop
	@mkdir_p@ $(COVERAGE_HS_DIR)
1648 96eccc1f Iustin Pop
	hpc combine --union $(HPCEXCL) \
1649 96eccc1f Iustin Pop
	  test.tix hpc-htools.tix > coverage-htools.tix
1650 896b2850 Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1651 896b2850 Iustin Pop
	hpc report coverage-htools.tix
1652 82888134 Michael Hanselmann
	$(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1653 b91e9518 Iustin Pop
1654 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1655 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1656 ec8379bd Iustin Pop
.PHONY: live-test
1657 ec8379bd Iustin Pop
live-test: all
1658 ec8379bd Iustin Pop
	set -e ; \
1659 ec8379bd Iustin Pop
	cd htools; \
1660 82888134 Michael Hanselmann
	rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1661 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1662 ec8379bd Iustin Pop
	./live-test.sh; \
1663 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1664 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1665 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1666 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1667 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1668 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1669 b91e9518 Iustin Pop
1670 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1671 b341b9ca Guido Trotter
1672 6438e259 Iustin Pop
.PHONY: gitignore-check
1673 6438e259 Iustin Pop
gitignore-check:
1674 6438e259 Iustin Pop
	@if [ -n "`git status --short`" ]; then \
1675 6438e259 Iustin Pop
	  echo "Git status is not clean!" 1>&2 ; \
1676 6438e259 Iustin Pop
	  git status --short; \
1677 6438e259 Iustin Pop
	  exit 1; \
1678 6438e259 Iustin Pop
	fi
1679 6438e259 Iustin Pop
1680 1d45f7a0 Iustin Pop
# we don't need the ancient implicit rules:
1681 1d45f7a0 Iustin Pop
%: %,v
1682 1d45f7a0 Iustin Pop
%: RCS/%,v
1683 1d45f7a0 Iustin Pop
%: RCS/%
1684 1d45f7a0 Iustin Pop
%: s.%
1685 1d45f7a0 Iustin Pop
%: SCCS/s.%
1686 1d45f7a0 Iustin Pop
1687 3baa809c Michael Hanselmann
-include ./Makefile.local
1688 3baa809c Michael Hanselmann
1689 e8230860 Michael Hanselmann
# vim: set noet :